#include "object.h"

Object::Object ()
{
  this->readFromObjFile ("reaphigh.obj");
    
  glEnableClientState (GL_VERTEX_ARRAY);
  glVertexPointer(3, GL_FLOAT, 0, vertices->getArray());
  
  listNumber = glGenLists(1);
  glNewList (listNumber, GL_COMPILE);

  glColor3f(1.0,0,0);
  glBegin(GL_QUADS);
  
  for (int i=0; i<=faces->getCount();++i)
    {
      printf ("%i, %i\n", i, (int) faces->getArray()[i]);
      glArrayElement((int)faces->getArray()[i] -1);
    }

  glEnd();
  glEndList();
}

void Object::draw ()
{
  glCallList (listNumber);

}




bool Object::readFromObjFile (char* fileName)
{
  if ( (OBJ_FILE = fopen (fileName, "r")) == NULL)
    {
      printf ("file: %s not found.\n", fileName);
      return false;
    }
  else
    {
      char Buffer[100];
      vertices = new Array();
      faces = new Array();
      char lastWas = '0';
	
      while (fscanf (OBJ_FILE, "%s", Buffer) != EOF)
	{
	  
	  // case we read it is a vertex
	  if (!strcmp (Buffer, "v"))
	    {
	      lastWas = 'v';
	    }
	  // case we read a Face
	  else if (!strcmp (Buffer, "f"))
	    {  
	      lastWas = 'f';
	    }
	  else if (!strcmp (Buffer, "vn"))
	    {
	      lastWas = 'n';
	    }
	  else if (!strcmp (Buffer, "vt"))
	    {
	      lastWas = 't';
	    }
	  else if (!strcmp (Buffer,"s"))
	    {
	      lastWas = '0';
	    }
	  else if (!strncmp (Buffer,"u", 1))
	    {
	      lastWas = '0';
	    }
	  else if (!strcmp (Buffer,"g"))
	    {
	      lastWas = '0';
	    }


	  // all other cases
	  else
	    {
	      if (lastWas == 'v')
		{
		  vertices->addEntry(atof(Buffer));
		  printf ("v: %s\n", Buffer);
		}
	      else if (lastWas == 'f')
		{
		  char* pointTo;
		  pointTo = strstr (Buffer, "/");
		  pointTo[0] = '\0';
		  printf ("f: %s\n", Buffer);
		  faces->addEntry(atof(Buffer));
		}
	      
	    }
	}
      vertices->finalizeArray();
      faces->finalizeArray();
      fclose (OBJ_FILE);
      printf("test\n");
      return true;
    }
}
